<template>
    <tr data-code-with-amount-id={{codeWithAmount.codeId}}>
        <input type="hidden" name="id" class="form-control" :value="codeWithAmount.id">
        <th scope="row">{{index + 1}}</th>
        <td>{{codeWithAmount.codeNumber}}</td>
        <td>{{codeWithAmount.codeName}}</td>
        <td v-if="editMode">
            <input class="form-control" type="number"
                :value="codeWithAmount.amount"
                @change="amountChanged">
        </td>
        <td v-else>{{codeWithAmount.amount}}</td>
    </tr>
</template>

<script>
    import { BudgetAmountsService } from '../../services/budgetAmountsService'
    import { defaultHandleErrorFunction } from '@/services/http-common'

    export default {
        name: 'BudgetCodeWithAmountRow',
        props: {
            detailsId: Number,
            codeWithAmount: Object,
            index: Number,
            editMode: Boolean
        },
        methods: {
            amountChanged(event) {
                var currentValue = this.codeWithAmount.amount;
                var newValue = event.target.value;
                if (currentValue == null && isNumeric(newValue))
                {
                    budgetAmountsService
                        .create(this.detailsId, this.codeWithAmount.codeId, newValue)
                        .then(this.codeWithAmount.amount = newValue)
                        .catch(defaultHandleErrorFunction);
                }
                else if (currentValue != null && !isNumeric(newValue))
                {
                    budgetAmountsService
                        .delete(this.detailsId, this.codeWithAmount.codeId)
                        .then(this.codeWithAmount.amount = null)
                        .catch(defaultHandleErrorFunction);
                }
                else if (currentValue != null && isNumeric(newValue))
                {
                    budgetAmountsService
                        .update(this.detailsId, this.codeWithAmount.codeId, newValue)
                        .then(this.codeWithAmount.amount = newValue)
                        .catch(defaultHandleErrorFunction);
                }
            }
        }
    };

    const budgetAmountsService = new BudgetAmountsService();

    function isNumeric(str) {
        if (typeof str != "string")
            return false
        return !isNaN(str) && !isNaN(parseFloat(str))
    }
</script>